;==============================
; 萔`
;==============================
;~[WbNCfbNX
SOUND_DEMO = 0                          ;I[vjOf
SOUND_OPENING = 1                       ;I[vjO
SOUND_S1DEMO = 2                        ;Xe[W1f
SOUND_S2DEMO = 3                        ;Xe[W2f
SOUND_ENDING = 4                        ;GfBO
SOUND_FIN = 5                           ;Xgf
SOUND_SHOT = 6                          ;Vbg
SOUND_MISS = 7                          ;Vbg
SOUND_DEFEAT = 8                        ;GɃqbg
SOUND_DAMAGE = 9                        ;}CLN^[_[W
SOUND_DEAD = 10                         ;}CLN^[S

;IuWFNgO[v
OBJECT_GROUP_MYNE = 1                   ;}CLN^[
OBJECT_GROUP_SHOT = 2                   ;Vbg
OBJECT_GROUP_ENEMY = 4                  ;G
OBJECT_GROUP_ENVIRON = 8                ;

;oG̍ő吔
STAR_COUNT_MAX = 50

;őqbg|Cg
HIT_POINT_MAX = 10

;eߎ
BULLET_TIMER_MAX = 1000                 ;Se
BULLET_TIMER_UNIT = 200                 ;P

;҂
WAIT_TIME_RELOAD = 50                   ;P[h
WAIT_TIME_STAGECLEAR = 500              ;Xe[WNA


;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Q[^CgFVisitor
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include "hgimg.as"

    chgdisp 1
    bgscr 2, 640, 480, 0

    hgini

    mouse -1

    title "Visitor"

    setfont 16, 16, 16, 1
    texload "font.bmp"

    sndload "demo.mp3", SOUND_DEMO
    sndload "opening.mp3", SOUND_OPENING
    sndload "s1demo.mp3", SOUND_S1DEMO
    sndload "s2demo.mp3", SOUND_S2DEMO
    sndload "ending.mp3", SOUND_ENDING
    sndload "fin.mp3", SOUND_FIN
    sndload "shot.wav", SOUND_SHOT
    sndload "miss.wav", SOUND_MISS
    sndload "defeat.wav", SOUND_DEFEAT
    sndload "damage.wav", SOUND_DAMAGE
    sndload "dead.wav", SOUND_DEAD


;********************************************************************************
; xF*Label_Demo
; Tv@@Ff
;********************************************************************************
*Label_Demo
    imageCount = 0
    imageCountMax = 7
    imageKind = "demo"
    drawTimeMax = 300
    snd SOUND_DEMO
    gosub *Label_SetImage
    sndoff

    wait 50


;********************************************************************************
; xF*Label_Opening
; Tv@@FI[vjO
;********************************************************************************
*Label_Opening
    imageCount = 0
    imageCountMax = 0
    imageKind = "opening"
    drawTimeMax = 1200
    keyPressFlag = 0
    snd SOUND_OPENING
    gosub *Label_SetImage
    sndoff

    if (keyPressFlag = 0) {
        wait 50
        goto *Label_Demo
    }

    wait 50

    stageCount = 0


;********************************************************************************
; xF*Label_StageDemo
; Tv@@FXe[Wf
;********************************************************************************
*Label_StageDemo
    stageCount += 1
    imageCount = 0
    if (stageCount = 1) {
        imageCountMax = 1
    } else if (stageCount = 2) {
        imageCountMax = 3
    }
    imageKind = "s" + stageCount + "demo"
    drawTimeMax = 500

    if (stageCount = 1) {
        snd SOUND_S1DEMO
    } else if (stageCount = 2) {
        snd SOUND_S2DEMO
    }
    gosub *Label_SetImage
    sndoff
    wait 50


;********************************************************************************
; xF*Label_GameStart
; Tv@@FQ[X^[g
;********************************************************************************
*Label_GameStart
    waitTime = 0

    texloadbg "back.bmp"

    setsizef 256.0f, 256.0f
    setuv 0, 0, 255, 255
    addmesh plateModel, 32, 32
    texload "floor" + stageCount + ".bmp"

    setsizef 8.0f, 8.0f
    setuv 0, 0, 127, 127
    addbox blockModel
    texload "block" + stageCount + ".bmp"

    setsizef 8.0f, 8.0f
    setuv 0, 0, 255, 255
    addplate enemy1Model, 1
    texload "enemy" + stageCount + "1.bmp"
    uvanim enemy1Model, 16, 4, 0

    setsizef 8.0f, 8.0f
    setuv 0, 0, 255, 255
    addplate enemy2Model, 1
    texload "enemy" + stageCount + "2.bmp"
    uvanim enemy2Model, 16, 4, 0

    setsizef 4.0f, 4.0f
    setuv 0, 0, 79, 79
    addplate shotModel, 1
    texload "shot.bmp"

    setsizef 8.0f, 8.0f
    setuv 0, 0, 63, 63
    addplate defeatModel, 1
    texload "defeat.bmp"
    uvanim defeatModel, 5, 10, 1

    setsizef 1.0f, 1.0f
    addbox myModel
    regobj myObject, myModel
    setcoli myObject, OBJECT_GROUP_MYNE, OBJECT_GROUP_ENEMY

    sdim stageMap, 1024
    repeat 1024
        poke stageMap, cnt, 0
    loop

    regobj plateObject, plateModel
    setcoli plateObject, OBJECT_GROUP_ENVIRON
    selang plateObject
    objset1r 0, 192
    selpos plateObject
    objset3 4, 0, 4

    randomize
    repeat 48
        regobj blockObject, blockModel
        setcoli blockObject, OBJECT_GROUP_ENVIRON
        rnd positionX, 32
        rnd positionZ, 32
        selpos blockObject
        objset3 (positionX - 16 * 8 + 4), -4, (positionZ - 16 * 8 + 4)
        poke stageMap, (32 * positionZ + positionX), 1
    loop

    clearFlag = 0
    enemyCount = 0
    enemyCountMax = 2 + stageCount * 2
    starCount = 0
    hitPoint = HIT_POINT_MAX
    bulletTimer = BULLET_TIMER_MAX

    setborder 256.0f, 32.0f, 256.0f
    selcang
    objset1r 1, 128
    selcpos
    objset3 0, -6, 0

    gsel 2


;********************************************************************************
; xF*Label_Main
; Tv@@FC
;********************************************************************************
*Label_Main
    stick keyCode, 255

    if (hitPoint < 1) {
        goto *Label_Environ
    }

    selcang
    objgetfv myAngle

    if (keyCode & 4) {
        fsub myAngle.1, 0.02f
    }

    if (keyCode & 1) {
        fadd myAngle.1, 0.02f
    }

    objsetfv myAngle

    fadd myAngle.1, 3.14f
    fvmul myAngle, -1.0f, -1.0f, -1.0f

    selcpos
    objgetfv myPosition

    selpos myObject
    objsetfv myPosition

    getcoli atackedEnemyID, myObject, 3.0f

    If (mutekiTimer > 0) {
        mutekiTimer -= 1
    }

    if (atackedEnemyID > -1) & (mutekiTimer = 0) {
        mutekiTimer = 30

        If (hitPoint > 0) {
            hitPoint -= 1
        }

        if (hitPoint = 0) {
            snd SOUND_DEAD
        } else {
            snd SOUND_DAMAGE
        }
    }

    if (keyCode & 2) {
        fvdir myAngle, 0.0f, 0.0f, 0.4f
        fvadd myPosition, myAngle.0, myAngle.1, myAngle.2
    }

    if (keyCode & 8) {
        fvdir myAngle, 0.0f, 0.0f, -0.2f
        fvadd myPosition, myAngle.0, myAngle.1, myAngle.2
    }

    fvmax myPosition, 128.0f, 8.0f, 128.0f
    fvmin myPosition, -128.0f, -8.0f, -128.0f

    f2i movePosition, myPosition.0, myPosition.1, myPosition.2

    positionX = movePosition.0 / 8 + 16
    positionZ = movePosition.2 / 8 + 16

    peek atariFlag, stageMap, 32 * positionZ + positionX

    if (atariFlag = 0) {
        selcpos
        objsetfv myPosition
    }

    findobj 0, 2

    repeat
        nextobj shotObject

        if (shotObject = -1) {
            break
        }

        getcoli hitEnemyID, shotObject, 3.0f

        if (hitEnemyID > -1) {
            selpos hitEnemyID
            objgetfv hitPosition
            delobj shotObject
            delobj hitEnemyID
            regobj defeatObject, defeatModel, OBJ_UVANIM_1SHOT
            selpos defeatObject
            objsetfv hitPosition
            snd SOUND_DEFEAT
            enemyCount -= 1
            starCount += 1
        }
    loop

    if (waitTime > 0) {
        waitTime -= 1
    }

    if (bulletTimer < BULLET_TIMER_MAX) {
        bulletTimer += 1
    }

    if (keyCode & 16 > 0) & (waitTime = 0) {
        if (bulletTimer > BULLET_TIMER_UNIT) {
            snd SOUND_SHOT
            bulletTimer = bulletTimer - BULLET_TIMER_UNIT
            regobj shotObject, shotModel, OBJ_MOVE|OBJ_BORDER
            setcoli shotObject, OBJECT_GROUP_SHOT, OBJECT_GROUP_ENEMY
            selpos shotObject
            objsetfv myPosition
            selcang
            objgetfv shotAngle
            fvdir shotAngle, 0.0f, 0.0f, 1.5f
            fvmul shotAngle, 1.0f, 1.0f, -1.0f
            seldir shotObject
            objsetf3 shotAngle.0, shotAngle.1, shotAngle.2
        } else {
            snd SOUND_MISS
        }
        waitTime = WAIT_TIME_RELOAD
    }


;********************************************************************************
; xF*Label_Environ
; Tv@@FQ[
;********************************************************************************
*Label_Environ
    restCount = STAR_COUNT_MAX - starCount
    if (enemyCount < enemyCountMax) and (restCount >= enemyCountMax) {
        gosub *Labal_EnemyBorn
    }

    gosub *Labal_EnemyMove

    hgdraw

    sdim hitPointMeterMax, HIT_POINT_MAX
    repeat HIT_POINT_MAX
        poke hitPointMeterMax, cnt, 2
    loop
    fprt hitPointMeterMax, 10, 10

    if (hitPoint > 0) {
        sdim hitPointMeter, hitPoint
        repeat hitPoint
            poke hitPointMeter, cnt, 1
        loop
        fprt hitPointMeter, 10, 10
    }

    sdim bulletCountMeter, (BULLET_TIMER_MAX / BULLET_TIMER_UNIT + 1)
    repeat (bulletTimer / BULLET_TIMER_UNIT)
        poke bulletCountMeter, cnt, 3
    loop
    fprt bulletCountMeter, 10, 450

    fprt "REST:" + restCount, 500, 450

    if (hitPoint < 1) {
        fprt "GAME OVER", 250, 200
    }

    if (restCount < 1) {
        fprt "STAGE CLEAR", 240, 200
        if (clearFlag = 0) {
            clearFlag = 1
            waitTime = WAIT_TIME_STAGECLEAR
        }
    }

    if (clearFlag = 1) and (waitTime = 0) {
        wait 50
        gosub *Label_DeleteObject
        if (stageCount = 2) {
            goto *Label_Ending
        } else {
            goto *Label_StageDemo
        }
    }

    hgsync 13

    if (keyCode & 128) {
        hgbye
        end
    }

    goto *Label_Main


;********************************************************************************
; xF*Labal_EnemyBorn
; Tv@@FG
;********************************************************************************
*Labal_EnemyBorn
    rnd positionZ, 32
    rnd positionX, 32

    peek enemyBurnPosition, stageMap, 32 * positionZ + positionX
    if (enemyBurnPosition = 0) {
        return
    }

    rnd enemyKind, 2
    if (enemyKind = 0) {
        regobj enemyObject, enemy1Model, OBJ_MOVE|OBJ_FLIP|OBJ_BORDER
    } else {
        regobj enemyObject, enemy2Model, OBJ_MOVE|OBJ_FLIP|OBJ_BORDER
    }
    setcoli enemyObject, OBJECT_GROUP_ENEMY
    selpos enemyObject
    objset3 (positionX - 16 * 8 + 4), -4, (positionZ - 16 * 8 + 4)
    enemyCount += 1

    return


;********************************************************************************
; xF*Labal_EnemyMove
; Tv@@FGړ
;********************************************************************************
*Labal_EnemyMove
    findobj 0, 4
    repeat
        nextobj enemyObject
        if (enemyObject = -1) {
            break
        }

        rnd randomValue, 3
        if (randomValue > 0) {
            break
        }

        selpos enemyObject
        objgetfv enemyPosition

        fvface enemyPosition, myPosition.0, -4.0f, myPosition.2
        fvdir enemyPosition, 0.0f, 0.0f, -0.2f
        seldir enemyObject
        objsetfv enemyPosition
    loop

    return


;********************************************************************************
; xF*Label_DeleteObject
; Tv@@FSIuWFNg폜
;********************************************************************************
*Label_DeleteObject
    findobj 0, OBJECT_GROUP_MYNE + OBJECT_GROUP_SHOT + OBJECT_GROUP_ENEMY + OBJECT_GROUP_ENVIRON

    repeat
        nextobj anyObject
        if (anyObject = -1) {
            break
        } else {
            delobj anyObject
        }
    loop

    return


;********************************************************************************
; xF*Label_Ending
; Tv@@FGfBO
;********************************************************************************
*Label_Ending
    imageCount = 0
    imageCountMax = 3
    imageKind = "ending"
    drawTimeMax = 500
    snd SOUND_ENDING
    gosub *Label_SetImage
    sndoff
    wait 50


;********************************************************************************
; xF*Label_Fin
; Tv@@FXgf
;********************************************************************************
*Label_Fin
    imageCount = 0
    imageCountMax = 7
    imageKind = "fin"
    drawTimeMax = 500
    snd SOUND_FIN
    gosub *Label_SetImage
    sndoff
    wait 50

    goto *Label_Demo


;********************************************************************************
; xF*Label_SetImage
; Tv@@FC[WZbg
;********************************************************************************
*Label_SetImage
    drawTimeCount = drawTimeMax
    if (imageCount > imageCountMax) {
        return
    }
    keyPressFlag = 0
    texloadbg imageKind + imageCount + ".bmp"

    gsel 2


;********************************************************************************
; xF*Label_SetImageMain
; Tv@@FC[WZbgC
;********************************************************************************
*Label_SetImageMain
    hgsync 30
    hgdraw

    drawTimeCount = drawTimeCount - 1
    if (drawTimeCount < 0) {
        imageCount = imageCount + 1
        goto *Label_SetImage
    }

    stick keyCode, 255

    if (keyCode = 128) > 0 {
        keyPressFlag = 1
        return
    }

    if (keyCode = 32) > 0 {
        wait 10
        keyPressFlag = 1
        drawTimeCount = 0
    }

    goto *Label_SetImageMain

